#include "ad_deriv.h"
#include <stdio.h>

#define MAXLEN 100
typedef struct {
   int         len;
   DERIV_TYPE* x, *y, r;
} data_t;
void ad_cos_angle(data_t*);

int main() {
    int    i, n;
    double grad[ad_GRAD_MAX], t1, t2;
    data_t data;
    DERIV_TYPE x[MAXLEN], y[MAXLEN], r;

    /*inialize*/
    ad_AD_Init(ad_GRAD_MAX);

    /* read in values*/
    scanf("%d", &n);
    for (i = 0; i < n; i++) {
        scanf("%lf %lf", &t1, &t2);
        ad_grad_axpy_0(&x[i]);
        DERIV_val(x[i]) = t1;
        ad_grad_axpy_0(&y[i]);
        DERIV_val(y[i]) = t2;
    }
    data.len = n; data.x = x; data.y = y;

    /*set independent variables*/
    ad_AD_SetIndepArray(x, n);
    ad_AD_SetIndepDone();

    /*invoke the function*/
    ad_cos_angle(&data);

    /*extract the gradient vector*/
    ad_AD_ExtractGrad(grad, data.r);

    /*print the result and partials*/
    printf("%le\n", DERIV_val(data.r));
    for (i = 0; i < n; i++) {
        printf ("%le\n", grad[i]);      /*partials*/
    }

    /*cleanup*/
    ad_AD_Final();
}   
