#include "ad_deriv.h"

void  ad_func(DERIV_TYPE [], DERIV_TYPE [], DERIV_TYPE);

int  main() {
  int row[9], col[9];
  DERIV_TYPE x[3], y[3], z;
  int i, j, k;
  double grad[6], hess[6][6];

  ad_AD_Init(); 

  /* Setup the row and column arrays */
  for (i=0; i<6; i++) {
    row[i] = i;
    col[i] = i;
  }
  row[6] = 0;
  col[6] = 2;
  row[7] = 1;
  col[7] = 4;
  row[8] = 3;
  col[8] = 4;

  /* Initialize the derivatives of the independent variables */
  for (i=0; i<3; i++) {
    ad_AD_InitTaylor(i, x[i], row, col);
    ad_AD_InitTaylor(i+3, y[i], row, col);
  }

  /* Compute the derivatives */
  ad_func(x, y, z);

  /* Extract the gradient and Hessian */
  ad_AD_InterpTaylor(z, grad, hess, row, col);

}
