#include <stdio.h>
#include "func.h"

int main() {
    int            i, n;
    data_t         data;
    double         x[MAXLEN], y[MAXLEN], r;
    InactiveDouble grad[ad_GRAD_MAX], val, t1, t2;

    /*inialize*/
    AD_Init(ad_GRAD_MAX);

    /* read in values*/
    scanf("%d", &n);
    for (i = 0; i < n; i++) {
        scanf("%lf %lf", &t1, &t2);
        x[i] = t1;
        y[i] = t2;
    }
    data.len = n; data.x = x; data.y = y;

    /*set independent variables*/
    AD_SetIndepArray(x, n);
    AD_SetIndepDone();

    /*invoke the function*/
    cos_angle(&data);

    /*extract the gradient vector*/
    AD_ExtractGrad(grad, data.r);
    AD_ExtractVal(val, data.r);

    /*print the result and partials*/
    printf("%le\n", val);
    for (i = 0; i < n; i++) {
        printf ("%le\n", grad[i]);      /*partials*/
    }

    /*cleanup*/
    AD_Final();
}   
