/************************** DISCLAIMER ********************************/
/*                                                                    */
/*   This file was generated on 06/10/97 14:49:55 by the version of   */
/*   ADIC compiled on  06/10/97 13:31:20                              */
/*                                                                    */
/*   ADIC was prepared as an account of work sponsored by an          */
/*   agency of the United States Government and the University of     */
/*   Chicago.  NEITHER THE AUTHOR(S), THE UNITED STATES GOVERNMENT    */
/*   NOR ANY AGENCY THEREOF, NOR THE UNIVERSITY OF CHICAGO, INCLUDING */
/*   ANY OF THEIR EMPLOYEES OR OFFICERS, MAKES ANY WARRANTY, EXPRESS  */
/*   OR IMPLIED, OR ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR */
/*   THE ACCURACY, COMPLETENESS, OR USEFULNESS OF ANY INFORMATION OR  */
/*   PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT INFRINGE */
/*   PRIVATELY OWNED RIGHTS.                                          */
/*                                                                    */
/**********************************************************************/
#include "ad_deriv.h"
void  ad_func(int , DERIV_TYPE [], DERIV_TYPE []);

void  main() {

  DERIV_TYPE x[10], y[3];
  double h_y[3][HESS_MAXVARS][HESS_MAXVARS],g_y[3][HESS_MAXVARS];
  int i,j,k,count;
  int map[HESS_MAXVARS][HESS_MAXVARS];

  ad_AD_Init();

  for (i = 0; i < 10; i++) 
    DERIV_val(x[i]) = (i + 1) * 1.0;

  printf("Taylor map before completion:\n");
  for (i=0; i<10; i++) {
    for (j=0; j<10; j++)
      map[i][j] = 0;
    for (j=i-3; j<=i+3; j++) 
      if (j >= 0 && j <10)
	map[i][j] = 1;
    for (j=0; j<10; j++)
      printf("%3d ", map[i][j]);
    printf("\n");
  }
  ad_AD_CompleteTaylorMap(map,10);
  printf("Taylor map after completion:\n");
  for (i=0; i<10; i++) {
    for (j=0; j<10; j++)
      printf("%3d ", map[i][j]);
    printf("\n");
  }

  for (i=0; i<10; i++)
    ad_AD_InitTaylor(i, map, x[i]);

  ad_func(10, x, y); 

  for (i=0; i<3; i++) 
    ad_AD_InterpTaylor(map, y[i], g_y[i], h_y[i])

  printf("y:\n");
  for (i=0; i<3; i++)
        printf("%8.2f ", y[i].value);
  printf("\n");

  printf("g_y:\n");
  for (i=0; i<3; i++) {
    for (j=0; j<10; j++) {
      printf("%8.2f ", g_y[i][j]);
    }
    printf("\n");
  }

  for (i=0; i<3; i++) {
    printf("h_y:\n");
    for (j=0; j<10; j++) {
      for (k=0; k<10; k++) {
        printf("%8.2f ", h_y[i][k][j]);     
      }
      printf("\n");
    }
    printf("\n");
  }
                  

}



