#line 463 "adic/run-map.w"
    #include <malloc.h>
    #include "run-map.h"
    
#line 163 "adic/run-map.w"
    void* ad_map_init(int dsize, int msize, int bsize, int asize)
    { 
        int 	i;
        Pair*	pa;
        MapEntry*	entry;
	char*	pblock;

	desc_size = dsize;
	entry_size = dsize + sizeof(Pair) - sizeof(double);
	if (asize == 0) {
	    buckets_per_block = DEFAULT_BUCKETS_PER_BLOCK;
	}
	else {
	    buckets_per_block = asize;
	}	  

	if (msize == 0) {
	    map_size = DEFAULT_MAP_SIZE;
	}
	else {
	    map_size = msize;
	}
	if (bsize == 0) {
	    entries_per_bucket = DEFAULT_BUCKET_SIZE;
	}
	else {
	    entries_per_bucket = bsize;
	}
	bucket_size = entries_per_bucket*entry_size;
	if (map) {
	    free(map);
	}
        map = calloc(map_size, sizeof(MapEntry) + bucket_size);
	entry = map;
        pblock = (char*)(map + map_size);
	for (i = 0; i < map_size; i++) {
	    entry->next = (Pair*)pblock;
	    pblock += bucket_size;
	    entry++;
	}

        freeList = 0;
	blockList = 0;
	curBlock = 0;
    }



#line 217 "adic/run-map.w"
    void ad_map_cleanup()
    {
        int 	i;
	
#line 228 "adic/run-map.w"
if (blockList) {
    genlist_t* block = blockList;
    genlist_t* tmp;
    while (tmp = block->next) {
        free(block);
	block = tmp;
    }
    free(block);
    blockList = 0;
}

#line 221 "adic/run-map.w"
        free(map);
	map = 0;
    }


#line 244 "adic/run-map.w"
/*
    void* ad_map_reg_array_d(double* base, int size)
    {
        assert(!array.base);
        array.base = base;
	array.top = base + size;
	array.desc = calloc(size, desc_size);
	array.isSingle = 0;
    }
*/

#line 259 "adic/run-map.w"
/*
    void* ad_map_reg_array_s(float* base, int size)
    {
        assert(!array.base);
        array.base = base;
	array.top = base + size/2;
	array.desc = calloc(size, desc_size);
	array.isSingle = 1;
    }
*/


#line 286 "adic/run-map.w"
    void* ad_map_get(void* key)
    {
        Pair *pa;
/*
        if (key < array.top && key >= array.base) {
	    if (array.isSingle) {
	        return array.desc + ((single*)key - (single*)array.base);
	    }
	    else {
	        return array.desc + ((double*)key - array.base);
	    }
	}
*/
        MapEntry*	entry = map + 
#line 346 "adic/run-map.w"
    (((int)key>>3) % map_size)

#line 299 "adic/run-map.w"
                                              ;
	if (entry->cache && entry->cache->key == key) {
	    return entry->cache->val;
	}
        while (1) {
	    int 	i = 0;
	    pa = entry->next;
	    while (++i < entries_per_bucket) {

#line 313 "adic/run-map.w"
	        if (pa->key == key) {
		    entry->cache = pa;
		    return pa->val;
	        }
		else if (!pa->key) {
		    pa->key = key;
		    entry->cache = pa;
		    return pa->val;
		}
		else {
		    pa = (Pair*)((char*)pa + entry_size);
		}
	    }
	    if (pa->key) {
#line 329 "adic/run-map.w"
		pa = (Pair*)pa->key;
	    }
	    else {
#line 335 "adic/run-map.w"
		Pair* tmp = 
#line 349 "adic/run-map.w"
    (Pair*)ad_map_alloc_bucket()


#line 335 "adic/run-map.w"
                                  ;
		pa->key = tmp;
		tmp->key = key;
		entry->cache = tmp;
		return tmp->val;
	    }
	}
    }


#line 362 "adic/run-map.w"
    static void* ad_map_alloc_bucket()
    {
#if defined(DEBUG)
	static 	count = 0;
	    if (++count >= gdebug.nTokens) {
		msg("Allocated %d tokens", count);
		count = 0;
	    }
	}
#endif
	static int	nBlocks;
        static int	nCurBucket;

	if (!curBlock || nCurBucket >= buckets_per_block) {
	    if (freeList) {
#line 379 "adic/run-map.w"
	        curBlock = freeList;
	        freeList = freeList->next;
	    }
	    else {
#line 388 "adic/run-map.w"
		curBlock = (genlist_t*)calloc(
                                sizeof(genlist_t) - sizeof(double) + 
				           buckets_per_block * bucket_size, 1);
	        curBlock->next = blockList;
		blockList = curBlock;
                nBlocks++;
            }
	    nCurBucket = 0;
	}
	return (char*)curBlock->data + (nCurBucket++)*bucket_size;
    }


#line 405 "adic/run-map.w"
   void* ad_map_free_bucket(void* ptr)
   {
#line 409 "adic/run-map.w"
#if defined(DEBUG)
	static 	count = 0;
        if (++count >= gdebug.nTokens) {
            msg("Freed %d tokens", count);
	    count = 0;
	}
#endif

	genlist_t*	list = freeList;
	freeList = (genlist_t*)ptr;
	freeList->next = list;
   }




#line 432 "adic/run-map.w"
void* ad_map_free(void* key)
{
    void** p = (void**)ad_map_get(key);
    *(p-1) = (void*)1;
}




