
package PurseConfig;
use Exporter;
@ISA = qw(Exporter);
@EXPORT_OK = qw(PurseConfig CheckLocation);

use PurseConstants 
    qw ($ADINTRINSICS_HOME 
	@TEMPLATE_DIRS
	$program);


sub PurseConfig {
    $ADINTRINSICS_HOME = $ENV{'ADINTRINSICS_C_HOME'};
    $ADINTRINSICS_HOME =~ s@/$@@;

    if ( $ADINTRINSICS_HOME eq "" )
    {
        die "$program: Need to set ADINTRINSICS_C_HOME\n";
    }
    
    if ( ( ! -d "$ADINTRINSICS_HOME" )
	|| ( ! -d "$ADINTRINSICS_HOME/templates" )
	|| ( ! -f "$ADINTRINSICS_HOME/templates/acos.T" )
	)
    {
	warn "$program: The directory ADINTRINSICS_C_HOME = $ADINTRINSICS_HOME appears not to be correct.\n";
	die "$program: Please check to make sure all of the templates are correctly installed\n";
    }

    @TEMPLATE_DIRS = ("$ADINTRINSICS_HOME/templates");
}


# This allows "tool" routines to assume they are building in the right place.
#

sub CheckLocation {
    die "$0: Need to run in ADIntrinsics-C distribution base directory\n"
	if ( ! -d "./gen" || ! -d "./gen/init" || ! -d "./gen/drivers" );
}
