# This file contains all of the constants people might want to know about.
# (Not little regular expressions and stuff---more global things.)
#
# NOTE: Although many of these are "constants" you should really consider
# them as "globals" instead.

use Exporter;

package PurseConstants;
@ISA = qw(Exporter);
@EXPORT = qw($ADINTRINSICS_HOME);
@EXPORT_OK = qw(
        $program
        $DRIVER_INPUT_FILE $DRIVER_OUTPUT_DIR

        $COMMON_DATA_INIT_DIR 
        $PARTIALS_INIT_FILE 
        $ENUM_INIT_FILE
	$NAMES_INIT_FILE
	$PROTO_FILE
        %PARTIAL_LOC 
        $ADINTR_MAX_PARTIALS

        $ADINTR_PREFIX
        $ADINTR_UC_PREFIX

	$ADIC_DRIVERS_OUTPUT_DIR
        $ADIC_DRIVERS_INPUT_BASE
	$ADIC_PROTO_FILE

        $FILE_NUMBER_VAR_NAME
        
        %unary_or_binary
        %known_intrinsics

        @TEMPLATE_DIRS
        $TEMPLATE_EXTENSION

	$INCLUDE_COMMENTS_IN_OUTPUT

	$begin_ignore_function_call
	$end_ignore_function_call
        );

# Program name to say when emitting errors
$program = "purse-c";

# This is the base that refers to everything
$ADINTRINSICS_HOME = "/Need/To/Set/ADINTRINSICS_C_HOME";


##
## For: driver-gen
##

# This tells the driver-gen program where the its template is
$DRIVER_INPUT_FILE = "inputs/driver.input";

$DRIVER_OUTPUT_DIR = "gen/drivers";

##
## For: common-*-gen
##

# Here is where the file that initializes the "ADIntr_Partial_Values" 
# block goes.
$COMMON_DATA_INIT_DIR = "gen/init";
$PARTIALS_INIT_FILE = "initcommon.h";
$ENUM_INIT_FILE = "initenum.h";
$NAMES_INIT_FILE = "names.h";
$PROTO_FILE = "adintr_proto.h";

$ADINTR_PREFIX = "adintr_";
$ADINTR_UC_PREFIX = "ADINTR_";

%PARTIAL_LOC = (
        "fx",0,
        "fy",1,
        "fxx",2,
        "fxy",3,
        "fyy",4
        );

$ADINTR_MAX_PARTIALS = 5;

##
## For: adic-drivers-gen
##

$ADIC_DRIVERS_OUTPUT_DIR = "gen/adic-drivers";
$ADIC_DRIVERS_INPUT_BASE = "inputs/g_input";
$ADIC_PROTO_FILE = "g_proto.h";

##
## ExpandTemplate.pm, purse.w
## 

$AD_INTRINSIC_FUNCTION_ID = "g_filenum";
$FILE_NUMBER_VAR_NAME = $AD_INTRINSIC_FUNCTION_ID;
$AD_INTRINSIC_SETUP_FUNCTION_ID = "adintr_ehsfid";

##
#
##

%unary_or_binary = (
"ABS",1,
"ACOS",1,
"ACOSH",1,
"ASIN",1,
"ASINH",1,
"ATAN",1,
"ATAN2",2,
"ATANH",1,
"CEIL",1,
"COS",1,
"COSH",1,
"EXP",1,
"FABS",1,
"FLOOR",1,
"FMOD",2,
"FREXP",2,
"LDEXP",2,
"LOG",1,
"LOG10",1,
"MODF",2,
"POW",2,
"MAX",2,
"MIN",2,
"SIN",1,
"SINH",1,
"SQRT",1,
"TAN",1,
"TANH",1,
"FMAX",2,
"FMIN",2
);

%known_intrinsics = %unary_or_binary;

##
# Template::Find
##

@TEMPLATE_DIRS = ("$ADINTRINSICS_HOME/templates");
$TEMPLATE_EXTENSION = ".T";

##
# TemplateList
##

# remember that TemplateList::all_templates returns a list of all 
# template files (including the .T suffix)

## 
# Say whether informative comments should be included in output; 
# the make code more readable, but make it impossible to comment out
# sections of code.
##

$INCLUDE_COMMENTS_IN_OUTPUT = 1;

##
# for AD_EXCEPTION_BEGIN_IGNORE / END_IGNORE
##

$begin_ignore_function_call = "adintr_mode_push(ADINTR_IGNORE);";
$end_ignore_function_call = "adintr_mode_pop();";

1;

